Open CASCADE Technology: StepData_FileProtocol Class Reference

Open CASCADE Technology 6.8.0

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
StepData_FileProtocol Class Reference

A FileProtocol is defined as the addition of several already existing Protocols. It corresponds to the definition of a SchemaName with several Names, each one being attached to a specific Protocol. Thus, a File defined with a compound Schema is processed as any other one, once built the equivalent compound Protocol, a FileProtocol. More...

`#include <StepData_FileProtocol.hxx>`

Inheritance diagram for StepData_FileProtocol:
[legend]

## Public Member Functions
| StepData_FileProtocol ()
| Creates an empty FileProtocol. More...
void | Add (const Handle< StepData_Protocol > &protocol)
| Adds a Protocol to the definition list of the FileProtocol But ensures that each class of Protocol is present only once in this list. More...
virtual Standard_Integer | NbResources () const
| Gives the count of Protocols used as Resource (can be zero) i.e. the count of Protocol recorded by calling the method Add. More...
virtual Handle < Interface_Protocol > | Resource (const Standard_Integer num) const
| Returns a Resource, given a rank. Here, rank of calling Add. More...
virtual Standard_Integer | TypeNumber (const Handle< Standard_Type > &atype) const
| Returns a Case Number, specific of each recognized Type Here, NO Type at all is recognized properly : all Types are recognized by the resources. More...
virtual Standard_Boolean | GlobalCheck (const Interface_Graph &G, Handle< Interface_Check > &ach) const
| Calls GlobalCheck for each of its recorded ressources. More...
virtual Standard_CString | SchemaName () const
| Returns the Schema Name attached to each class of Protocol To be redefined by each sub-class Here, SchemaName returns "" (empty String) was C++ : return const. More...
Public Member Functions inherited from StepData_Protocol
| StepData_Protocol ()
Standard_Integer | NbResources () const
| Gives the count of Protocols used as Resource (can be zero) Here, No resource. More...
Handle< Interface_Protocol > | Resource (const Standard_Integer num) const
| Returns a Resource, given a rank. Here, none. More...
virtual Standard_Integer | CaseNumber (const Handle< Standard_Transient > &obj) const
| Returns a unique positive number for any recognized entity Redefined to work by calling both TypeNumber and, for a Described Entity (late binding) DescrNumber. More...
Standard_Integer | TypeNumber (const Handle< Standard_Type > &atype) const
| Returns a Case Number, specific of each recognized Type Here, only Unknown Entity is recognized. More...
Handle< Interface_InterfaceModel > | NewModel () const
| Creates an empty Model for Step Norm. More...
Standard_Boolean | IsSuitableModel (const Handle< Interface_InterfaceModel > &model) const
| Returns True if <model> is a Model of Step Norm. More...
Handle< Standard_Transient > | UnknownEntity () const
| Creates a new Unknown Entity for Step (UndefinedEntity) More...
Standard_Boolean | IsUnknownEntity (const Handle< Standard_Transient > &ent) const
| Returns True if <ent> is an Unknown Entity for the Norm, i.e. Type UndefinedEntity, status Unknown. More...
virtual Standard_Integer | DescrNumber (const Handle< StepData_EDescr > &adescr) const
| Returns a unique positive CaseNumber for types described by an EDescr (late binding) Warning : TypeNumber and DescrNumber must give together a unique positive case number for each distinct case, type or descr. More...
void | AddDescr (const Handle< StepData_EDescr > &adescr, const Standard_Integer CN)
| Records an EDescr with its case number Also records its name for an ESDescr (simple type): an ESDescr is then used, for case number, or for type name. More...
Standard_Boolean | HasDescr () const
| Tells if a Protocol brings at least one ESDescr, i.e. if it defines at least one entity description by ESDescr mechanism. More...
Handle< StepData_EDescr > | Descr (const Standard_Integer num) const
| Returns the description attached to a case number, or null. More...
Handle< StepData_EDescr > | Descr (const Standard_CString name, const Standard_Boolean anylevel=Standard_True) const
| Returns a description according to its name <anylevel> True (D) : for <me> and its resources <anylevel> False : for <me> only. More...
Handle< StepData_ESDescr > | ESDescr (const Standard_CString name, const Standard_Boolean anylevel=Standard_True) const
| Idem as Descr but cast to simple description. More...
Handle< StepData_ECDescr > | ECDescr (const TColStd_SequenceOfAsciiString &names, const Standard_Boolean anylevel=Standard_True) const
| Returns a complex description according to list of names <anylevel> True (D) : for <me> and its resources <anylevel> False : for <me> only. More...
void | AddPDescr (const Handle< StepData_PDescr > &pdescr)
| Records an PDescr. More...
Handle< StepData_PDescr > | PDescr (const Standard_CString name, const Standard_Boolean anylevel=Standard_True) const
| Returns a parameter description according to its name <anylevel> True (D) : for <me> and its resources <anylevel> False : for <me> only. More...
void | AddBasicDescr (const Handle< StepData_ESDescr > &esdescr)
| Records an ESDescr, intended to build complex descriptions. More...
Handle< StepData_EDescr > | BasicDescr (const Standard_CString name, const Standard_Boolean anylevel=Standard_True) const
| Returns a basic description according to its name <anylevel> True (D) : for <me> and its resources <anylevel> False : for <me> only. More...
Public Member Functions inherited from Interface_Protocol
virtual Standard_Boolean | IsDynamicType (const Handle< Standard_Transient > &obj) const
| Returns True if type of <obj> is that defined from CDL This is the default but it may change according implementation. More...
virtual Standard_Integer | NbTypes (const Handle< Standard_Transient > &obj) const
| Returns the count of DISTINCT types under which an entity may be processed. Each one is candidate to be recognized by TypeNumber, <obj> is then processed according it By default, returns 1 (the DynamicType) More...
Handle< Standard_Type > | Type (const Handle< Standard_Transient > &obj, const Standard_Integer nt=1) const
| Returns a type under which <obj> can be recognized and processed, according its rank in its definition list (see NbTypes). By default, returns DynamicType. More...
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Additional Inherited Members
Static Public Member Functions inherited from Interface_Protocol
static Handle< Interface_Protocol > | Active ()
| Returns the Active Protocol, if defined (else, returns a Null Handle, which means "no defined active protocol") More...
static void | SetActive (const Handle< Interface_Protocol > &aprotocol)
| Sets a given Protocol to be the Active one (for the users of Active, see just above). Applies to every sub-type of Protocol. More...
static void | ClearActive ()
| Erases the Active Protocol (hence it becomes undefined) More...

## Detailed Description

A FileProtocol is defined as the addition of several already existing Protocols. It corresponds to the definition of a SchemaName with several Names, each one being attached to a specific Protocol. Thus, a File defined with a compound Schema is processed as any other one, once built the equivalent compound Protocol, a FileProtocol.

## Constructor & Destructor Documentation

StepData_FileProtocol::StepData_FileProtocol | ( |  | ) |

Creates an empty FileProtocol.

## Member Function Documentation

void StepData_FileProtocol::Add | ( | const Handle< StepData_Protocol > & | protocol | ) |

Adds a Protocol to the definition list of the FileProtocol But ensures that each class of Protocol is present only once in this list.

virtual Standard_Boolean StepData_FileProtocol::GlobalCheck | ( | const Interface_Graph & | G,
|  | Handle< Interface_Check > & | ach
| ) |  | const
| virtual

Calls GlobalCheck for each of its recorded ressources.

Reimplemented from Interface_Protocol.

virtual Standard_Integer StepData_FileProtocol::NbResources | ( |  | ) | const
| virtual

Gives the count of Protocols used as Resource (can be zero) i.e. the count of Protocol recorded by calling the method Add.

Implements Interface_Protocol.

virtual Handle< Interface_Protocol > StepData_FileProtocol::Resource | ( | const Standard_Integer | num | ) | const
| virtual

Returns a Resource, given a rank. Here, rank of calling Add.

Implements Interface_Protocol.

virtual Standard_CString StepData_FileProtocol::SchemaName | ( |  | ) | const
| virtual

Returns the Schema Name attached to each class of Protocol To be redefined by each sub-class Here, SchemaName returns "" (empty String) was C++ : return const.

Reimplemented from StepData_Protocol.

Reimplemented in StepData_DescrProtocol.

virtual Standard_Integer StepData_FileProtocol::TypeNumber | ( | const Handle< Standard_Type > & | atype | ) | const
| virtual

Returns a Case Number, specific of each recognized Type Here, NO Type at all is recognized properly : all Types are recognized by the resources.

Implements Interface_Protocol.

The documentation for this class was generated from the following file:

- StepData_FileProtocol.hxx